Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email notifications Estimated time: 0.00 hour

Target version:

Resolution: Invalid

Description

Redmine outgoing email does not provide a reply-to header. Many email relays which require a user-id/pw login (e.g.
smtp.gmail.com) replace the sender@domain with the user-id of the login account. Consequently, when the receiver replies to the
email, it goes to the login user-id and domain, rather than the sender user@domain set by redmine where the issue originated.

This patch provides a check-box in the email-notifications settings which, when set, causes redmine to provide a reply-to header
identical to the sender (user@domain). This allows replies to be routed to the redmine instance where they originated, and be
incorporated into the issue.

The attached tarball of .diff files is for:

redmine-4.1.1

ruby 2.6.6p146 (not relevant)

Rails 5.2.4.2 (provides base mailer, not especially relevant)
mysql 5.7 (not relevant)

plugins: Additionals (not relevant)

History

#1 - 2021-03-06 19:26 - Marius BALTEANU

- Status changed from New to Needs feedback

You can set in_reply: <address> in email_delivery settings from configuration.yml (source:trunk/config/configuration.yml.example#L 15). It's not
enough?

https://guides.rubyonrails.org/action_mailer_basics.html#action-mailer-configuration

#2 - 2021-03-07 16:26 - Gary Aitken
Marius BALTEANU wrote:

You can set in_reply: <address> in email_delivery settings from configuration.yml (source:trunk/config/configuration.yml.example#L 15). It's not
enough?

Is that actually possible in all cases? | just tried setting from:, reply_to:, in_reply:, and sender: for a delivery method of :sendmail and got "mapping
values are not allowed in this context". So while it may be allowed for a delivery method of :smtp, it doesn't appear to be allowed for a delivery
method of :sendmail.

However, even if it were, that raises the question -- why does redmine provide a way to set the sender in the outgoing email settings, when (if it
worked in all cases) presumably that could also be set in configuration.yml?

#3 - 2021-03-08 23:39 - Marius BALTEANU
Gary Aitken wrote:
Is that actually possible in all cases? | just tried setting from:, reply_to:, in_reply:, and sender: for a delivery method of :sendmail and got
"mapping values are not allowed in this context". So while it may be allowed for a delivery method of :smtp, it doesn't appear to be allowed for a
delivery method of :sendmail.
Can you show me how your configuration looks (please anonymise your data)? For example, the following works for me:
email_delivery:

delivery_method: :smtp
smtp_settings:
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/config/configuration.yml.example#L15
https://guides.rubyonrails.org/action_mailer_basics.html#action-mailer-configuration
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/config/configuration.yml.example#L15

address: "maildev"

port: 25

enable_starttls_auto: false
default_options:

reply_to: noreply@example.com

According to Rails configuration, default_options is not a setting related only to smtp delivery method.

However, even if it were, that raises the question -- why does redmine provide a way to set the sender in the outgoing email settings, when (if it
worked in all cases) presumably that could also be set in configuration.yml|?

The setting has 14 years old and unfortunately, | cannot say why was made configurable in the Administration.

#4 - 2021-03-09 18:44 - Gary Aitken

Normally, configuration.yml looks like this:

default:
email_delivery:
delivery_method: :sendmail

and that's it.
There is no additional smtp configuration.

If I modify it to look like this:

default:
email_delivery:
delivery_method: :sendmail
smtp_settings:
reply_to: user@domain.com

and send a test mail, there is no reply-to field in the message which is sent.

In this installation, the mail is sent via the postfix (not sendmail) /usr/sbin/sendmail command, which delivers to the local postfix installation, which
relays over smtp through a gmail relay using their extra level of authentication. | don't know much about how the postfix sendmail command works,
except that you can run it from the command line. In order to get a reply-to header, you have to add it in the output yourself, like so:

$ sendmail user@domain.com

Subject: Test from mydomain.com using "sendmail"
Reply-to: foo@mydomain.com

some text

#5 - 2021-03-09 21:36 - Marius BALTEANU
This is incorrect:
default:
email_delivery:
delivery_method: :sendmail

smtp_settings:
reply_to: user@domain.com

reply_to is not an attribute of smtp_settings, it is of default_options.

Please try with the following:

default:
email_delivery:
delivery_method: :sendmail
default_options:
reply_to: user@domain.com

#6 - 2021-03-10 20:27 - Gary Aitken

That worked fine.
My appologies for taking up your time.

#7 - 2021-03-10 22:35 - Marius BALTEANU
- Tracker changed from Patch to Feature

- Status changed from Needs feedback to Closed
- Resolution set to Invalid

Gary Aitken wrote:

That worked fine.

My appologies for taking up your time.

Great! I'm closing this.

Files
reply_to.tar 7.5 KB 2021-03-04 Gary Aitken
